/**
 *
 */
package org.quintet.backbeat.composition;

import java.lang.reflect.Method;
import java.util.logging.Level;

import org.quintet.backbeat.bandstand.Bandstand;

/** 
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * An <code>EnvVarInjection</code> injects a literal value into a <i>passage-like object</i>.  The injected value is initially manifested as a <code>String</code>.  The <code>EnvVarInjection</code> will convert the injected value into any java.lang.* primitive type, such as Long, Integer, or Boolean.
 * @uml.annotations
 *     derived_abstraction="platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_TJTkYNnkEd2M4cCnHXbxDA"
 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_TJTkYNnkEd2M4cCnHXbxDA"
 */
public abstract class EnvVarInjection extends Injection {

	/** 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target
	 * @param bandstand
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_rXsJENnmEd2M4cCnHXbxDA"
	 */
	public void injectInto(Object target, Bandstand bandstand) {
		// begin-user-code
		Method setter = null;
		Class injectionClass = getActualManifestation().getClass();
		try {
			setter = target.getClass().getMethod(getSetterName(),
					new Class[] { injectionClass });
			setter.invoke(target, new Object[] { getActualManifestation() });
		} catch (Throwable t) {
			String err = t.getClass().getName() + 
			" when trying to inject a "+
			injectionClass.getName() + 
			" into an object of type "+
			target.getClass().getName();
			log.log(Level.SEVERE,err,t);
		}
		// end-user-code
	}

	/** 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param inSetterName
	 * @param inStringManifestation
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_kdwWYNqiEd2M4cCnHXbxDA"
	 */
	public EnvVarInjection(String inSetterName, String inStringManifestation) {
		// begin-user-code
		super(inSetterName, inStringManifestation);
		// end-user-code
	}
}
