/**
 *
 */
package org.quintet.backbeat.composition;

import java.lang.reflect.Method;
import java.util.logging.Level;
import java.util.logging.Logger;

import java.util.Collection;
import org.quintet.backbeat.bandstand.Bandstand;

/**
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * A <code>PassageDelegate</code> wraps a non-<code>Passage</code> object in a thin Passage-like veneer and then delegates <code>play()</code> and <code>setResource</code> calls to the appropriate methods in the wrapped non-<code>Passage</code> object.
 * @uml.annotations
 *     derived_abstraction="platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_w-eXQNEmEd2Q-KQSGThZCg"
 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_w-eXQNEmEd2Q-KQSGThZCg"
 */
public class PassageDelegate implements Passage {
	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_EbeeUNEuEd2Q-KQSGThZCg"
	 */
	private Object wrapped;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the wrapped
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_EbeeUNEuEd2Q-KQSGThZCg?GETTER"
	 */
	public Object getWrapped() {
		// begin-user-code
		return wrapped;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theWrapped the wrapped to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_EbeeUNEuEd2Q-KQSGThZCg?SETTER"
	 */
	public void setWrapped(Object theWrapped) {
		// begin-user-code
		wrapped = theWrapped;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_jkTYUNrCEd2M4cCnHXbxDA"
	 */
	private static Logger log = Logger
			.getLogger("org.quintet.backbeat.composition");

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the log
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_jkTYUNrCEd2M4cCnHXbxDA?GETTER"
	 */
	public static Logger getLog() {
		// begin-user-code
		return log;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#__bKZYNrhEd2M4cCnHXbxDA"
	 */
	private Bandstand bandstand;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the bandstand
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#__bKZYNrhEd2M4cCnHXbxDA?GETTER"
	 */
	public Bandstand getBandstand() {
		// begin-user-code
		return bandstand;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theBandstand the bandstand to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#__bKZYNrhEd2M4cCnHXbxDA?SETTER"
	 */
	public void setBandstand(Bandstand theBandstand) {
		// begin-user-code
		bandstand = theBandstand;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_csBEUNriEd2M4cCnHXbxDA"
	 */
	private Collection<Injection> resources;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the resources
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_csBEUNriEd2M4cCnHXbxDA?GETTER"
	 */
	public Collection<Injection> getResources() {
		// begin-user-code
		return resources;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theResources the resources to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_csBEUNriEd2M4cCnHXbxDA?SETTER"
	 */
	public void setResources(Collection<Injection> theResources) {
		// begin-user-code
		resources = theResources;

		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_qqwZMNtoEd2Qy-8DGL5OcA"
	 */
	private String methodName;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the methodName
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_qqwZMNtoEd2Qy-8DGL5OcA?GETTER"
	 */
	public String getMethodName() {
		// begin-user-code
		return methodName;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theMethodName the methodName to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_qqwZMNtoEd2Qy-8DGL5OcA?SETTER"
	 */
	public void setMethodName(String theMethodName) {
		// begin-user-code
		methodName = theMethodName;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_g3ZZMNueEd2Qy-8DGL5OcA"
	 */
	private String methodArgTypeName;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the methodArgTypeName
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_g3ZZMNueEd2Qy-8DGL5OcA?GETTER"
	 */
	public String getMethodArgTypeName() {
		// begin-user-code
		return methodArgTypeName;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theMethodArgTypeName the methodArgTypeName to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_g3ZZMNueEd2Qy-8DGL5OcA?SETTER"
	 */
	public void setMethodArgTypeName(String theMethodArgTypeName) {
		// begin-user-code
		methodArgTypeName = theMethodArgTypeName;
		//fetch an instance of the corresponding class
		Class _class = null;
		try{
			this.setMethodArgType(Class.forName(methodArgTypeName));
		}catch(Throwable cnfe){
			String err = "Unable to create a class named \""+methodArgTypeName+"\"";
			log.log(Level.SEVERE,err,cnfe);
			throw new IllegalStateException(err,cnfe);
		}
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 *
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_kehQ4NueEd2Qy-8DGL5OcA"
	 */
	private Class methodArgType;

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the methodArgType
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_kehQ4NueEd2Qy-8DGL5OcA?GETTER"
	 */
	public Class getMethodArgType() {
		// begin-user-code
		return methodArgType;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param theMethodArgType the methodArgType to set
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_kehQ4NueEd2Qy-8DGL5OcA?SETTER"
	 */
	public void setMethodArgType(Class theMethodArgType) {
		// begin-user-code
		methodArgType = theMethodArgType;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param inWrapped
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_LKlaoNEuEd2Q-KQSGThZCg"
	 */
	public PassageDelegate(Object inWrapped) {
		// begin-user-code
		// TODO Auto-generated constructor stub
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_iVH4INqxEd2M4cCnHXbxDA"
	 */
	public int getOrder() {
		// begin-user-code
		// TODO Auto-generated method stub
		return 0;
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param newValue
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_jhasINqxEd2M4cCnHXbxDA"
	 */
	public void setOrder(int newValue) {
		// begin-user-code
		// TODO Auto-generated method stub

		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param inName
	 * @param inOrder
	 * @param inPassageClassName
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_3puD4NrBEd2M4cCnHXbxDA"
	 */
	public PassageDelegate(String inName, String inOrder,
			String inPassageClassName) {
		// begin-user-code
		Class passageClass = null;
		try {
			passageClass = Class.forName(inPassageClassName);
			Object it = passageClass.newInstance();
			this.setWrapped(it);
		} catch (Throwable t) {
			String err = t.getClass().getName()
					+ "when trying to create class \"" + inPassageClassName
					+ "\"";
			log.log(Level.SEVERE, err, t);
			throw new IllegalStateException(err, t);
		}
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param injections
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_UoY-8NtMEd2Qy-8DGL5OcA"
	 */
	public void setInjections(Collection<Injection> injections) {
		// begin-user-code
		for (Injection injection : injections) {
			injection.injectInto(this, getBandstand());
		}

		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * (non-Javadoc)
	 * @see Passage#play(Object history)
	 * @generated
	 */
	public Object play(Object history) {
		// begin-user-code
		// find the "play" method on the impl
		Method player = null;
		Class argType = this.getMethodArgType();
		if(argType == null)
			argType = java.lang.Object.class;
		try {
			player = getWrapped().getClass().getMethod(getMethodName(),
					new Class[] { argType });
			return player.invoke(getWrapped(), new Object[] { history });
		} catch (Throwable t) {
			String err = t.getClass().getName() + " when invoking method \""
					+ getMethodName() + "\" " + "on object of class \""
					+ getWrapped().getClass() + "\" "
					+ "with argument of type \"" + history.getClass().getName()
					+ "\"";
			log.log(Level.SEVERE, err, t);
			throw new IllegalStateException(err, t);
		}
		// end-user-code
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * (non-Javadoc)
	 * @see Passage#getImplementation()
	 * @generated
	 */
	public Object getImplementation() {
		// begin-user-code
		// TODO Auto-generated method stub
		Object impl = this.getWrapped();
		if (impl == null)
			return this;
		else
			return impl;
		// end-user-code
	}
}
