/**
 * 
 */
package org.quintet.backbeat.composition;

import java.lang.reflect.Method;
import java.util.logging.Level;

import org.quintet.backbeat.bandstand.Bandstand;

/** 
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * A <code>ResourceInjection</code>  finds a designated <i>resource</i> (e.g., a DataSource, a JMS Queue) via the <code>Bandstand</code>.  Its <code>injectInto</code> method accepts the name of the resource to be injected.  It looks up that resource via the <code>Bandstand</code> and then injects it into a <i>passage-like-object</i>.
 * @uml.annotations
 *     derived_abstraction="platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_QzZc8NnkEd2M4cCnHXbxDA"
 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_QzZc8NnkEd2M4cCnHXbxDA"
 */
public class ResourceInjection extends Injection {

	/** 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param inSetterName
	 * @param inResourceName
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_BhvYENqlEd2M4cCnHXbxDA"
	 */
	public ResourceInjection(String inSetterName, String inResourceName) {
		// begin-user-code
		super(inSetterName, inResourceName);
		// end-user-code
	}

	/** 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @param target
	 * @param bandstand
	 * @generated "sourceid:platform:/resource/Quintet_2/JavaUMLModel1229572370608.emx#_bas44NtPEd2Qy-8DGL5OcA"
	 */
	public void injectInto(Object target, Bandstand bandstand) {
		// begin-user-code
		// use our string manifestation as a key to look up the actual value
		Object found = bandstand.lookup(getStringManifestation());
		this.setActualManifestation(found);
		Method setter = null;
		Class injectionClass = this.getActualManifestation().getClass();
		try {
			setter = target.getClass().getMethod(getSetterName(),
					new Class[] { injectionClass });
			setter.invoke(target, new Object[] { getActualManifestation() });
		} catch (Throwable t) {
			String err = t.getClass().getName() + 
			" when trying to inject a "+
			injectionClass.getName() + 
			" into an object of type "+
			target.getClass().getName();
			log.log(Level.SEVERE,err,t);
		}

		// end-user-code
	}
}