package org.quintet.backbeat.dataportal;

import org.quintet.backbeat.BackBeatException;



/**
 *
 *  A <code>DataPortal</code> is a means of acquiring data from some external
 * (external to the system, but not necessarily external to the corporation)
 *  source.
 *
 * @author Peter Thaggard
 * @version     1
 * @since       Quintet 2004_1
 */
public interface DataPortal
{

  /**
   * Obtain some data from somewhere.  The <code>context</code> helps determine
   * what data will be obtained; <code>context</code> is almost always a
   * request that specifies the desired data.
   * @param context Object
   * @return Object
   * @throws BackBeatException
   */
  public Object getData(Object context) throws BackBeatException;
}
