package org.quintet.backbeat.io;

import org.quintet.chambers.EntityRetriever;
import org.quintet.chambers.RetrieverException;
import java.util.logging.Logger;
import java.util.logging.Level;
import java.io.StringBufferInputStream;
//yes, I know it's deprecated, but I'm going to use it anyway


/**
 * <code>BlobAsStreamRetriever</code> attaches a <code>StringStream</code> to a
 * "blob" of data.  It provides a simple means of treating a String of
 * in-memory data as though it were a <code>File</code>.
 *
 * <p>Copyright: Copyright (c) 2007</p>
 *
 * <p>Company: 6th Sense Analytics</p>
 *
 * @author Peter Thaggard 6th Sense Analytics
 * @version 1.0
 */
public class BlobAsStreamRetriever implements EntityRetriever {

    private static final Logger log = Logger.getLogger("org.quintet.backbeat");
    public BlobAsStreamRetriever() {
    }

    /**
     * "Retrieve" the request whose unique identifier is <code>pk</code> and
     * return the fully-formed request to the caller.
     *
     * @param pk Object
     * @return java.lang.Object
     * @throws RetrieverException
     * @todo Implement this org.quintet.chambers.EntityRetriever method
     */
    public Object retrieve(Object pk) throws RetrieverException {
        if(pk == null){
            String err = "pk is null, therefore returning a null";
            log.log(Level.FINE,err);
            return null;
        }
        if(pk instanceof String){
            String blob = (String)pk;
            StringBufferInputStream answer = new StringBufferInputStream(blob);
            return answer;
        }else{
            String warn = "expected a String, got a " +
                          pk.getClass().getName();
            log.log(Level.WARNING,warn);
            return pk;
        }
    }

    public static void main(String[] args) {
    }
}
