package org.quintet.backbeat.io;

import org.quintet.backbeat.BackBeatException;

/**
 *
 * <p>Title: InputConduit</p>
 * <p>Description: The <code>InputConduit</code> interface fecilitates
 * reading data from external world.  Any class that implements
 * this interface will turn external data into an internl representation.
 * This can be contrasted with <code>OutputConduit</code> which
 * fecilitates calsses to write data to the external world.
 * <p>Copyright: Copyright (c) 2004</p>
 * @version 2.1
 * @see org.quintet.backbeat.io.OutputConduit
 * @see org.quintet.backbeat.io.JDBCInputConduit
 * @see org.quintet.backbeat.io.FTPInputConduit
 * @see org.quintet.backbeat.io.FileInputConduit
 */

public interface InputConduit {
   public Object getData(Object data) throws BackBeatException;
}
