package org.quintet.backbeat.io;

import org.quintet.backbeat.BackBeatException;
/**
 *
 * <p>Title: OutputConduit</p>
 * <p>Description: The <code>OutputConduit</code> interface fecilitates
 * writing data out to the external world.  Any class that implements
 * this interface will turn its internal-format data into an external
 * format.  This can be contrasted with <code>InputConduit</code> which
 * fecilitates calsses to read data from the external world and turn it
 * into an internal format.
 * <p>Copyright: Copyright (c) 2004</p>
 * @version 2.1
 * @see org.quintet.backbeat.io.InputConduit
 * @see org.quintet.backbeat.io.JDBCOutputConduit
 * @see org.quintet.backbeat.io.FTPOutputConduit
 * @see org.quintet.backbeat.io.FileOutputConduit
 */

public interface OutputConduit
{

   public Object writeData(Object data) throws BackBeatException;
}
