package org.quintet.backbeat.transformer;

import org.quintet.monk.XMLFactory;
import org.quintet.monk.XMLInfoException;
import java.util.logging.Logger;
import java.util.logging.Level;

public class MapToXMLTransformer implements Transformer {

  private static final Logger log = Logger.getLogger("org.quintet.backbeat");

  public Object transform(Object original) throws TransformerException {
    if(original == null)
      return null;
    try {
      return XMLFactory.createXML(original);
    }
    catch (XMLInfoException ex) {
      String err = "XMLInfoException when processing object of type " + original.getClass().getName();
      log.log(Level.SEVERE,err,ex);
      throw new TransformerException(err,ex);
    }
  }
}
