package org.quintet.backbeat.transformer;


/**
The <code>Transformer</code> interface contractually binds it realizing classes
to provide a method called <code>transform</code>.  This method accepts an
<code>Object</code>, transforms its to a new manifestation, and returns the
manifestation to the caller.
 */
public interface Transformer
{


   /**
   Transform <code>inRawData</code> to a new manifestation and return the new
   manifestation to the client.
   @param inRawData - The raw data to be transformed to a new manifestation
   @return java.lang.Object
   @throws org.quintet.backbeat.transformer.TransformerException
   @throws TransformerException
   @roseuid 40A3B4C60280
    */
   public Object transform(Object inRawData) throws TransformerException;
}
