package org.quintet.backbeat.transformer;

import java.io.FileOutputStream;
import java.io.PrintWriter;
import java.io.IOException;

public class XMLToFileTransformer implements Transformer{
  public XMLToFileTransformer() throws TransformerException{

  }

  public Object transform(Object inRawData) throws TransformerException{
    if(inRawData == null)
      return null;
    FileOutputStream fos = null;
    PrintWriter writer = null;
    try{
      if(inRawData instanceof java.lang.String){
        fos = new FileOutputStream((String)inRawData);
        writer = new PrintWriter(fos);
        writer.println((String)inRawData);
        writer.flush();
        writer.close();
        return null;
      }else{
        throw new TransformerException("Expected a String, got a " +
                                       inRawData.getClass().getName());
      }
    }catch(IOException ioe){
      throw new TransformerException("XMLToFileTransformer:transform:ERROR:IOException:"+ioe,ioe);
    }finally{
      if(writer != null){
        try{
          writer.close();
        }catch(Throwable eatIt){}
      }
      if(fos != null){
        try{
          fos.close();
        }catch(Throwable eatIt){}
      }
    }
  }
}


