package org.quintet.chambers;

import javax.ejb.EJBLocalHome;
import javax.ejb.CreateException;
import java.io.InputStream;

public interface EntityFactoryLocalHome extends EJBLocalHome
{

  /**
   * Create an <code>EntityFactory</code> instance that utilizes the <i>blueprints</i>
   * found in the <code>blueprintsStream</code> <code>InputStream</code>
   * @return org.quintet.chambers.EntityFactory
   * @throws java.rmi.RemoteException
   * @throws javax.ejb.CreateException
   * @roseuid 407FF4F800B4
   */
  public EntityFactory create(InputStream blueprintsStream) throws CreateException;

  /**
   * Create an <code>EntityFactory</code> that utilizes the <i>blueprints</i> found in
   * the file at <code>blueprintsURL</code>
   * @param blueprintsURL String -- The URL of a blueprints file
   * @throws RemoteException
   * @throws CreateException
   * @return EntityFactory
   */
   public EntityFactory create(String blueprintsURL) throws CreateException;
}
