package org.quintet.coltrane;

import java.util.ArrayList;
import java.util.Collection;

/**
 * A universe of <code>RuleSet</code>s that govern behavior within a specific domain.
 */
public class Rules {
	
	/**
	 * The collection of all <code>RuleSet</code>s that operate in this <code>Rules</code> universe.
	 */
	private Collection ruleSets = new ArrayList();
	
	/**
	 * @roseuid 3ECD415E02E1
	 */
	public Rules() {
		
	}
	
	/**
	 * Access method for the ruleSets property.
	 * 
	 * @return   the current value of the ruleSets property
	 */
	public Collection getRuleSets() {
		return ruleSets;
		}
	
	/**
	 * Sets the value of the ruleSets property.
	 * 
	 * @param aRuleSets the new value of the ruleSets property
	 */
	public void setRuleSets(Collection aRuleSets) {
		ruleSets = aRuleSets;
		}
	
	/**
	 * This method exists purely to convince <code>Introspector</code> that <code>Rules</code> contains a property named "classRuleSet".
	 * @return org.quintet.coltrane.RuleSet
	 * @roseuid 3ECD40470380
	 */
	public RuleSet getClassRuleSet() {
		return null;
	}
	
	/**
	 * This method exists so that <code>RuleSet</code>s can be added to this <code>Rules</code> via the JavaBeans introspection mechanism; calling this method actually results in the passed-in <code>RuleSet</code> being added to this <code>Rules</code>' 
	 * <code>ruleSets</code> collection.
	 * @param inRuleSet
	 * @roseuid 3ECD408F004E
	 */
	public void setClassRuleSet(RuleSet inRuleSet) {
	   ruleSets.add(inRuleSet);		
	}
}
