package org.quintet.ellington;

import java.util.Map;
import java.util.Collection;
import org.quintet.QuintetException;
import java.util.logging.Logger;
import java.util.logging.Level;

/**
 * The <code>Arranger</code> is responsible for injecting an object with
 * configuration information.  <code>Arranger</code> is an abstract class, so
 * it must be reified in one or more concrete subclasses.  At a minimum there
 * are two such concrete subclasses, <code>JNDIArranger</code> and <code>
 * <code>PropertyFileArranger</code>.
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: 6th Sense Analytics</p>
 *
 * @author Peter Thaggard
 * @version 1.0
 */
public abstract class Arranger {
  protected static final Logger log = Logger.getLogger("org.quintet.ellington");
  public Arranger() {
    super();
  }

  public abstract Map<String,Object> arrange(String[] propertyNames) throws QuintetException;
}
