package org.quintet.miles;

import org.quintet.miles.Range;
import org.quintet.miles.SingleValueRange;
import org.quintet.miles.MultiplexAggregation;
import org.quintet.miles.Aggregation;
import org.quintet.miles.UnaryRange;
import org.quintet.miles.BinaryRange;
import org.quintet.miles.MultiplexAggregation;
import java.util.Collection;
import java.util.Iterator;
import java.util.Date;
import java.text.DateFormat;
import java.text.SimpleDateFormat;
import java.text.ParseException;
import org.quintet.backbeat.transformer.TransformerException;
import org.quintet.monk.Monk;
import org.quintet.monk.MonkException;
import java.lang.reflect.Method;
import java.io.InputStream;
import java.io.IOException;
import org.quintet.monk.XMLFactory;
import org.quintet.monk.XMLInfoException;
import java.lang.reflect.*;

import org.quintet.backbeat.transformer.TransformerException;
import java.sql.Timestamp;

public class AggregationTest
    implements Comparable {
  public void setObservationTime(Long observationTime) {
    this.observationTime = observationTime;
  }

  public void setObservationType(String observationType) {
    this.observationType = observationType;
  }

  public void setObservationSite(String observationSite) {
    this.observationSite = observationSite;
  }

  public void setOrganizationName(String organizationName) {
    this.organizationName = organizationName;
  }

  public void setPrincipalID(String principalID) {
    this.principalID = principalID;
  }

  public void setObservationCategory(String observationCategory) {
    this.observationCategory = observationCategory;
  }

  public int compareTo(Object inRHS) {

    if (inRHS instanceof AggregationTest) {
      AggregationTest rhs = (AggregationTest) inRHS;
      return getObservationTime().compareTo(rhs.getObservationTime());
    }else{
      return -1;
    }
  }

  /**
      @roseuid 424AE14C017C
   */
  public AggregationTest() {

  }

  /**
   * create some bogus entities, instantiate some aggregations from an XML blueprints file,
   * run the entities through the aggregations, convert the aggregations to xml, output the
   * resulting XML
   * @param portfolio AggregationTest[]
   */
  public static void testXMLAggregation(AggregationTest[] portfolio) {
    Range topLevel = null;
    InputStream blueprintsStream = null;
    InputStream aggregationsStream = null;

    try {
      blueprintsStream = AggregationTest.class.getResourceAsStream(
          "blueprints.xml");
      if (blueprintsStream == null) {
        System.err.println("cannot find blueprints file");
        return;
      }
      aggregationsStream = new java.io.FileInputStream("c:/6thWorkspace/6thServer/config/sixth-aggregation.xml");
      Monk monk = Monk.createMonk(blueprintsStream);
      topLevel = (Range) monk.create(aggregationsStream);
    }catch(java.io.IOException ioe){
      System.err.println("IOE:  " + ioe);
      return;
    }
    catch (MonkException ex) {
      System.err.println("ObjectFactoryException:  " + ex);
      return;
    }

    for (int idx = 0; idx < portfolio.length; idx++) {
      topLevel.add(portfolio[idx]);
    }
    try {
      String answer = XMLFactory.createXML(topLevel);
      /*ProductGroupToExcel transformer = new ProductGroupToExcel();
             Object it = transformer.transform(answer);*/
      try{
        java.io.FileOutputStream fos = new java.io.FileOutputStream("c:/tmp/answer.xml");
        java.io.PrintWriter pw = new java.io.PrintWriter(fos);
        pw.println(answer);
        pw.flush();
        pw.close();
      }catch(java.io.IOException ioe){
        System.err.println("IOE:  " + ioe);
      }
    }
    catch (XMLInfoException ex1) {
      System.err.println("XMLInfoException:  " + ex1);
      return;
    }
    //String struc = topLevel.getStructure(1);
    //System.out.println(struc);

  }

  private static String[] principals = new String[]{"todd","brec","peter"};
  private static String[] categories = new String[]{"EDIT","DEBUG","VIEW","BUILD"};
  /**
      @param argv
      @roseuid 424AE0FF0262
   */
  public static void main(String[] argv) {
    java.text.DateFormat dateFormat = new java.text.SimpleDateFormat("MM/dd/yyyy HH:mm:ss a");
    Date start = null;
    try {
      start = dateFormat.parse("01/01/2005 00:00:00 AM");
    }
    catch (ParseException ex) {
      System.err.println("ParseException:  " + ex);
      System.exit(-1);
    }

    AggregationTest[] tests = new AggregationTest[1000];
    long curr = start.getTime();
    for (int idx = 0; idx < 1000; idx++) {
      tests[idx] = new AggregationTest();
      curr += (60*60*8*1000); // 8 hours
      tests[idx].setObservationTime(new Long(curr));
      tests[idx].setOrganizationName("6th");
      tests[idx].setPrincipalID(principals[idx%3]);
      tests[idx].setObservationCategory(categories[idx % 4]);
    }

    testXMLAggregation(tests);

  }

  private Long observationTime = null;
  private String organizationName = null;
  private String principalID = null;
  private String observationCategory = null;

  private String observationSite;
  private String observationType;

  public String getObservationType() {
    return observationType;
  }

  public String getObservationSite() {
    return observationSite;
  }

  public Long getObservationTime() {
    return observationTime;
  }

  public String getOrganizationName() {
    return organizationName;
  }

  public String getPrincipalID() {
    return principalID;
  }

  public String getObservationCategory() {
    return observationCategory;
  }

}
