package org.quintet.miles;

import java.io.Serializable;

public class Pair<Left extends Serializable,Right extends Serializable> implements Serializable{

	public Left LHS;

	public Right RHS;

        public Pair(){

        }
	public Pair(Left inLHS, Right inRHS){
		if(null == inLHS || null == inRHS){
			throw new IllegalArgumentException("Pair does not accept null objects");
		}

		LHS = inLHS;

		RHS = inRHS;

	}


	public int hashCode(){
		return LHS.hashCode() ^ RHS.hashCode();
	}

	public boolean equals(Pair inRHS){
		try{
			Pair<Left,Right> rho = (Pair<Left,Right>)inRHS;
			return this.LHS.equals(rho.LHS) && this.RHS.equals(rho.RHS);
		}catch(ClassCastException cce){
			return false;
		}
	}
}
