package org.quintet.miles;

import java.util.Collection;
import java.util.Iterator;
import java.util.ArrayList;

import java.util.logging.Logger;
import java.util.logging.Level;


/**
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: 6th Sense Analytics</p>
 *
 * @author Peter Thaggard
 * @version 1.0
 */
public class RangeCollection<T extends Range> extends ArrayList<T> implements Collection<T>  {

    private static final Logger log = Logger.getLogger("org.quintet.miles");

  public RangeCollection() {
      log.finest("RangeCollection ctor");
  }

  /**
   * Kludgy little method to return this <code>RangeCollection</code>
   * @return RangeCollection&lt;T extends Range&gt;
   */
  public RangeCollection<T> getThis(){
    return this;
  }
  /**
   * Find the <code>Range</code> whose <i>declared node structure</i> equals <code>inNodeStructure</code>
   * and whose <i>aggregation type</i> equals <code>inAggregationType</code>
   * @param inNodeStructure String
   * @param inAggregationType String
   * @return Range
   */
  public T findRange(String inNodeStructure, String inAggregationType){
    for(T m:this){
      String memberNodeStructure = m.getDeclaredNodeStructure();
      String memberAggType = m.getAggregationType();
      if(null != memberNodeStructure && memberNodeStructure.equals(inNodeStructure) &&
         null != memberAggType && memberAggType.equals(inAggregationType))
           return m;
    }
    return null;
  }
}
