package org.quintet.miles;

import java.io.Serializable;

/**
 * <code>RangeSurgeon</code> classes perform "surgery" on <code>Range</code>s
 * and return the modified results back to their callers; for example, a
 * <code>RangeSurgeon</code> might eliminate some <code>Range</code> members,
 * thereby acting as a pruning mechanism.
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * @author Peter Thaggard
 * @version 1.0
 */
public interface RangeSurgeon extends Serializable{

    /**
     * Modify <code>sourceRange</code> in some way and return the modified
     * <code>Range</code> to the caller
     * @param sourceRange Range
     * @return Range
     * @throws AggregationException
     */
    public Range operateOn(Range sourceRange) throws AggregationException;

}
