package org.quintet.monk;

import java.io.InputStream;
import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;

import org.w3c.dom.Document;
import org.xml.sax.SAXParseException;


public class DocumentProcessor {
  /**
   * Parse the XML Document located in <code>inObjectStream</code>, return the object manifestation(s) found therein.
   * @param inObjectStream - The <code>InputStream</code>from which to read objects
   * @return java.lang.Object
   * @throws org.quintet.monk.MonkException
   * @roseuid 3ECD5D8F02F3
   */
  public Object process(InputStream inObjectStream) throws
      MonkException {
    String response = null;
    try {

      DocumentBuilderFactory docBuilderFactory = DocumentBuilderFactory.
          newInstance();
      DocumentBuilder docBuilder = docBuilderFactory.newDocumentBuilder();
      Document doc = docBuilder.parse(inObjectStream);
      doc.getDocumentElement().normalize();

      //turn the tree into some java objects
      Monk factory = Monk.createMonk();
      Object commands = factory.create(doc);
      return commands;
    }
    catch (SAXParseException SPE) {
      MonkException x = new MonkException(
          "caught an error parsing input:", SPE);
      x.setOriginalException(SPE);
      throw x;

    }
    catch (Exception SE) {
      MonkException x = new MonkException(
          "caught an error parsing input:", SE);
      SE.printStackTrace();
      x.setOriginalException(SE);
      throw x;
    }
  }
}
