package org.quintet.monk;

import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

import java.util.logging.Logger;
import java.util.logging.Level;

/**
 * <p> </p>
 *
 * <p> </p>
 *
 * <p>Copyright: Copyright (c) 2006</p>
 *
 * <p>Company: 6th Sense Analytics</p>
 *
 * @author Peter Thaggard
 * @version 1.0
 */
public class MonkErrorHandler implements ErrorHandler {

  private static final Logger log = Logger.getLogger("org.quintet.monk");

  public MonkErrorHandler() {
  }

  /**
   * Receive notification of a recoverable error.
   *
   * @param exception The error information encapsulated in a SAX parse
   *   exception.
   * @throws SAXException Any SAX exception, possibly wrapping another
   *   exception.
   * @todo Implement this org.xml.sax.ErrorHandler method
   */
  public void error(SAXParseException exception) throws SAXException {
    int lineNumber = exception.getLineNumber();
    int colNumber = exception.getColumnNumber();
    String info = "Encountered an error " + exception.getClass().getName() +
        ":  " + exception.getMessage() +
        ": line " + lineNumber + ": column " + colNumber;
    log.log(Level.WARNING,info);
  }

  /**
   * Receive notification of a non-recoverable error.
   *
   * @param exception The error information encapsulated in a SAX parse
   *   exception.
   * @throws SAXException Any SAX exception, possibly wrapping another
   *   exception.
   * @todo Implement this org.xml.sax.ErrorHandler method
   */
  public void fatalError(SAXParseException exception) throws SAXException {
    int lineNumber = exception.getLineNumber();
    int colNumber = exception.getColumnNumber();
    String info = "Encountered a fatal error " + exception.getClass().getName() +
        ":  " + exception.getMessage() +
        ": line " + lineNumber + ": column " + colNumber;
    log.log(Level.WARNING,info);
  }

  /**
   * Receive notification of a warning.
   *
   * @param exception The warning information encapsulated in a SAX parse
   *   exception.
   * @throws SAXException Any SAX exception, possibly wrapping another
   *   exception.
   * @todo Implement this org.xml.sax.ErrorHandler method
   */
  public void warning(SAXParseException exception) throws SAXException {
    int lineNumber = exception.getLineNumber();
    int colNumber = exception.getColumnNumber();
    String info = "Encountered a warning " + exception.getClass().getName() +
        ":  " + exception.getMessage() +
        ": line " + lineNumber + ": column " + colNumber;
    log.log(Level.WARNING,info);
  }
}
