package org.quintet.monk;

import org.quintet.QuintetException;
import org.w3c.dom.Node;

public class MonkException extends QuintetException
{

   /**
   (Optional) The name of the attribute which cause <code>Monk</code> to
   raise an exception
    */
   private String errantAttributeName = null;

   /**
   (Optional) The name of the <code>Class</code> that was being processed when
   <code>Monk</code> raised an exception.
    */
   private String errantClassName = null;

   /**
   MonkExceptopm holds the ClassMetaData of the object it was trying to create.
   This information is potentially valuable to Monk's clients
    */
   private ClassMetaData classMetaData = null;

   /**
   MonkException holds the errant DOM node that caused the exception to be raised.
    */
   private String errantNode = null;

   /**
   @param pMessage
   @roseuid 4128C67402F8
    */
   public MonkException(String pMessage)
   {
    super(pMessage);
   }

   /**
   @param pMessage
   @param pPreviousException
   @roseuid 4128C67402DB
    */
   public MonkException(String pMessage, Throwable pPreviousException)
   {
    super(pMessage, pPreviousException);
   }

   /**
   @roseuid 407FF32C02A7
    */
   public MonkException()
   {
    super();
   }

   /**
   Access method for the errantAttributeName property.

   @return   the current value of the errantAttributeName property
    */
   public String getErrantAttributeName()
   {
      return errantAttributeName;
   }

   /**
   Sets the value of the errantAttributeName property.

   @param aErrantAttributeName the new value of the errantAttributeName property
    */
   public void setErrantAttributeName(String aErrantAttributeName)
   {
      errantAttributeName = aErrantAttributeName;
   }

   /**
   Access method for the errantClassName property.

   @return   the current value of the errantClassName property
    */
   public String getErrantClassName()
   {
      return errantClassName;
   }

   /**
   Sets the value of the errantClassName property.

   @param aErrantClassName the new value of the errantClassName property
    */
   public void setErrantClassName(String aErrantClassName)
   {
      errantClassName = aErrantClassName;
   }

   /**
   @return org.quintet.monk.ClassMetaData
   @roseuid 4128C674029E
    */
   public ClassMetaData getClassMetaData()
   {
    return classMetaData;
   }

   /**
   @return org.w3c.dom.Node
   @roseuid 4128C67402A8
    */
   public String getErrantNode()
   {
    return errantNode;
   }

   /**
   @param inValue
   @roseuid 4128C67402BC
    */
   public void setErrantNode(Node inValue)
   {
    errantNode = inValue.toString();
   }
   public void setErrantNode(String inValue)
   {
     errantNode = inValue;
   }

   /**
   @param inValue
   @roseuid 4128C67402D0
    */
   public void setClassMetaData(ClassMetaData inValue)
   {
    classMetaData = inValue;
   }
}
/*
void MonkException.setErrantNode(javax.xml.soap.Node){
    setErrantNode(inValue);
  }
 */
