package org.quintet.miles;

import java.util.Collection;

public class TestDN {

  public static void main(String[] argv) {
    String dnStr = null;

    if (argv.length == 1) {
      dnStr = argv[0];
    }
    else {
      dnStr = "org=6th Sense,principal=Thaggard,category=EDIT,week=01/25/2006";
    }

    DN dn = null;
    DN cloned = null;
    try {
      dn = new DN(dnStr);
      System.out.println("original dn is '" + dn.toString() + "'");
      cloned = (DN) dn.clone();
      System.out.println("new dn is '" + cloned.toString() + "'");
    }
    catch (AggregationException ae) {
      System.err.println("Exception on dn '" + dnStr + "':  " + ae.toString());
      System.exit( -1);
    }

    Collection<DNNode<String, String>> nodes = dn.getNodes();

    for (DNNode<String, String> currNode : nodes) {
      System.out.println(currNode.LHS + "==>" + currNode.RHS + ":  " +
                         currNode.isLhsRollup() + ":" + currNode.getOriginalLHS());
    }

    for (DNNode<String, String> currNode : cloned.getNodes()) {
      System.out.println("[clone]" + currNode.LHS + "==>" + currNode.RHS + ":  " +
                         currNode.isLhsRollup() + ":" + currNode.getOriginalLHS());
    }
  }
}
